## qemu 1.3.0+dfsg

=== libcacard/Makefile ===
-include ../config-host.mak
-include $(SRC_PATH)/rules.mak
-include $(SRC_PATH)/Makefile.objs

libcacard_includedir=$(includedir)/cacard

$(call set-vpath, $(SRC_PATH))

# objects linked into a shared library, built with libtool with -fPIC if required
QEMU_OBJS=$(oslib-obj-y) qemu-timer-common.o $(trace-obj-y) $(stub-obj-y)
QEMU_OBJS_LIB=$(patsubst %.o,%.lo,$(QEMU_OBJS))

QEMU_CFLAGS+=-I../

libcacard.lib-y=$(patsubst %.o,%.lo,$(libcacard-y))

vscclient: $(libcacard-y) $(QEMU_OBJS) vscclient.o cutils.o
	$(call quiet-command,$(CC) -o $@ $^ $(libcacard_libs) $(LIBS),"  LINK  $@")

clean:
	rm -f *.o */*.o *.d */*.d *.a */*.a *~ */*~ vscclient *.lo */*.lo .libs/* */.libs/* *.la */*.la *.pc
	rm -Rf .libs */.libs

all: libcacard.la libcacard.pc
# Dummy command so that make thinks it has done something
	@true

#########################################################################
# Rules for building libcacard standalone library

ifeq ($(LIBTOOL),)
libcacard.la:
	@echo "libtool is missing, please install and rerun configure"; exit 1

install-libcacard:
	@echo "libtool is missing, please install and rerun configure"; exit 1
else
libcacard.la: $(libcacard.lib-y) $(QEMU_OBJS_LIB)
	$(call quiet-command,$(LIBTOOL) --mode=link --quiet --tag=CC $(CC) -rpath $(libdir) -o $@ $^ $(libcacard_libs),"  lt LINK $@")

libcacard_srcpath=$(SRC_PATH)/libcacard
libcacard.pc: $(libcacard_srcpath)/libcacard.pc.in
	$(call quiet-command,sed -e 's|@LIBDIR@|$(libdir)|' \
		-e 's|@INCLUDEDIR@|$(libcacard_includedir)|' \
	    -e 's|@VERSION@|$(shell cat $(SRC_PATH)/VERSION)|' \
		-e 's|@PREFIX@|$(prefix)|' \
		< $(libcacard_srcpath)/libcacard.pc.in > libcacard.pc,\
	"  GEN   $@")

.PHONY: install-libcacard

install-libcacard: libcacard.pc libcacard.la vscclient
	$(INSTALL_DIR) "$(DESTDIR)$(libdir)"
	$(INSTALL_DIR) "$(DESTDIR)$(libdir)/pkgconfig"
	$(INSTALL_DIR) "$(DESTDIR)$(libcacard_includedir)"
	$(INSTALL_DIR) "$(DESTDIR)$(bindir)"
	$(LIBTOOL) --mode=install $(INSTALL_PROG) vscclient "$(DESTDIR)$(bindir)"
	$(LIBTOOL) --mode=install $(INSTALL_DATA) libcacard.la "$(DESTDIR)$(libdir)"
	$(LIBTOOL) --mode=install $(INSTALL_DATA) libcacard.pc "$(DESTDIR)$(libdir)/pkgconfig"
	for inc in *.h; do \
		$(LIBTOOL) --mode=install $(INSTALL_DATA) $(libcacard_srcpath)/$$inc "$(DESTDIR)$(libcacard_includedir)"; \
	done
endif

=== tests/Makefile ===
export SRC_PATH

check-unit-y = tests/check-qdict$(EXESUF)
check-unit-y += tests/check-qfloat$(EXESUF)
check-unit-y += tests/check-qint$(EXESUF)
check-unit-y += tests/check-qstring$(EXESUF)
check-unit-y += tests/check-qlist$(EXESUF)
check-unit-y += tests/check-qjson$(EXESUF)
check-unit-y += tests/test-qmp-output-visitor$(EXESUF)
check-unit-y += tests/test-qmp-input-visitor$(EXESUF)
check-unit-y += tests/test-qmp-input-strict$(EXESUF)
check-unit-y += tests/test-qmp-commands$(EXESUF)
check-unit-y += tests/test-string-input-visitor$(EXESUF)
check-unit-y += tests/test-string-output-visitor$(EXESUF)
check-unit-y += tests/test-coroutine$(EXESUF)
check-unit-y += tests/test-visitor-serialization$(EXESUF)
check-unit-y += tests/test-iov$(EXESUF)
check-unit-y += tests/test-aio$(EXESUF)
check-unit-y += tests/test-thread-pool$(EXESUF)

check-block-$(CONFIG_POSIX) += tests/qemu-iotests-quick.sh

# All QTests for now are POSIX-only, but the dependencies are
# really in libqtest, not in the testcases themselves.
check-qtest-i386-y = tests/fdc-test$(EXESUF)
check-qtest-i386-y += tests/hd-geo-test$(EXESUF)
check-qtest-i386-y += tests/rtc-test$(EXESUF)
check-qtest-x86_64-y = $(check-qtest-i386-y)
check-qtest-sparc-y = tests/m48t59-test$(EXESUF)
check-qtest-sparc64-y = tests/m48t59-test$(EXESUF)

GENERATED_HEADERS += tests/test-qapi-types.h tests/test-qapi-visit.h tests/test-qmp-commands.h

test-obj-y = tests/check-qint.o tests/check-qstring.o tests/check-qdict.o \
	tests/check-qlist.o tests/check-qfloat.o tests/check-qjson.o \
	tests/test-coroutine.o tests/test-string-output-visitor.o \
	tests/test-string-input-visitor.o tests/test-qmp-output-visitor.o \
	tests/test-qmp-input-visitor.o tests/test-qmp-input-strict.o \
	tests/test-qmp-commands.o tests/test-visitor-serialization.o

test-qapi-obj-y =  $(qobject-obj-y) $(qapi-obj-y) qemu-tool.o
test-qapi-obj-y += tests/test-qapi-visit.o tests/test-qapi-types.o
test-qapi-obj-y += module.o

$(test-obj-y): QEMU_INCLUDES += -Itests

tests/check-qint$(EXESUF): tests/check-qint.o qint.o
tests/check-qstring$(EXESUF): tests/check-qstring.o qstring.o
tests/check-qdict$(EXESUF): tests/check-qdict.o qdict.o qfloat.o qint.o qstring.o qbool.o qlist.o
tests/check-qlist$(EXESUF): tests/check-qlist.o qlist.o qint.o
tests/check-qfloat$(EXESUF): tests/check-qfloat.o qfloat.o
tests/check-qjson$(EXESUF): tests/check-qjson.o $(qobject-obj-y) qemu-tool.o
tests/test-coroutine$(EXESUF): tests/test-coroutine.o $(coroutine-obj-y) $(tools-obj-y) $(block-obj-y) iov.o libqemustub.a
tests/test-aio$(EXESUF): tests/test-aio.o $(coroutine-obj-y) $(tools-obj-y) $(block-obj-y) libqemustub.a
tests/test-thread-pool$(EXESUF): tests/test-thread-pool.o $(coroutine-obj-y) $(tools-obj-y) $(block-obj-y) libqemustub.a
tests/test-iov$(EXESUF): tests/test-iov.o iov.o

tests/test-qapi-types.c tests/test-qapi-types.h :\
$(SRC_PATH)/qapi-schema-test.json $(SRC_PATH)/scripts/qapi-types.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-types.py $(gen-out-type) -o tests -p "test-" < $<, "  GEN   $@")
tests/test-qapi-visit.c tests/test-qapi-visit.h :\
$(SRC_PATH)/qapi-schema-test.json $(SRC_PATH)/scripts/qapi-visit.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-visit.py $(gen-out-type) -o tests -p "test-" < $<, "  GEN   $@")
tests/test-qmp-commands.h tests/test-qmp-marshal.c :\
$(SRC_PATH)/qapi-schema-test.json $(SRC_PATH)/scripts/qapi-commands.py
	$(call quiet-command,$(PYTHON) $(SRC_PATH)/scripts/qapi-commands.py $(gen-out-type) -o tests -p "test-" < $<, "  GEN   $@")


tests/test-string-output-visitor$(EXESUF): tests/test-string-output-visitor.o $(test-qapi-obj-y)
tests/test-string-input-visitor$(EXESUF): tests/test-string-input-visitor.o $(test-qapi-obj-y)
tests/test-qmp-output-visitor$(EXESUF): tests/test-qmp-output-visitor.o $(test-qapi-obj-y)
tests/test-qmp-input-visitor$(EXESUF): tests/test-qmp-input-visitor.o $(test-qapi-obj-y)
tests/test-qmp-input-strict$(EXESUF): tests/test-qmp-input-strict.o $(test-qapi-obj-y)
tests/test-qmp-commands$(EXESUF): tests/test-qmp-commands.o tests/test-qmp-marshal.o $(test-qapi-obj-y)
tests/test-visitor-serialization$(EXESUF): tests/test-visitor-serialization.o $(test-qapi-obj-y)

tests/rtc-test$(EXESUF): tests/rtc-test.o $(trace-obj-y)
tests/m48t59-test$(EXESUF): tests/m48t59-test.o $(trace-obj-y)
tests/fdc-test$(EXESUF): tests/fdc-test.o tests/libqtest.o $(trace-obj-y)
tests/hd-geo-test$(EXESUF): tests/hd-geo-test.o tests/libqtest.o $(trace-obj-y)

# QTest rules

TARGETS=$(patsubst %-softmmu,%, $(filter %-softmmu,$(TARGET_DIRS)))
QTEST_TARGETS=$(foreach TARGET,$(TARGETS), $(if $(check-qtest-$(TARGET)-y), $(TARGET),))
check-qtest-$(CONFIG_POSIX)=$(foreach TARGET,$(TARGETS), $(check-qtest-$(TARGET)-y))

qtest-obj-y = tests/libqtest.o $(oslib-obj-y) libqemustub.a
$(check-qtest-y): $(qtest-obj-y)

.PHONY: check-help
check-help:
	@echo "Regression testing targets:"
	@echo
	@echo " make check                Run all tests"
	@echo " make check-qtest-TARGET   Run qtest tests for given target"
	@echo " make check-qtest          Run qtest tests"
	@echo " make check-unit           Run qobject tests"
	@echo " make check-block          Run block tests"
	@echo " make check-report.html    Generates an HTML test report"
	@echo
	@echo "Please note that HTML reports do not regenerate if the unit tests"
	@echo "has not changed."
	@echo
	@echo "The variable SPEED can be set to control the gtester speed setting."
	@echo "Default options are -k and (for make V=1) --verbose; they can be"
	@echo "changed with variable GTESTER_OPTIONS."

SPEED = quick
GTESTER_OPTIONS = -k $(if $(V),--verbose,-q)

# gtester tests, possibly with verbose output

.PHONY: $(patsubst %, check-qtest-%, $(QTEST_TARGETS))
$(patsubst %, check-qtest-%, $(QTEST_TARGETS)): check-qtest-%: $(check-qtest-y)
	$(call quiet-command,QTEST_QEMU_BINARY=$*-softmmu/qemu-system-$* \
		gtester $(GTESTER_OPTIONS) -m=$(SPEED) $(check-qtest-$*-y),"GTESTER $@")

.PHONY: $(patsubst %, check-%, $(check-unit-y))
$(patsubst %, check-%, $(check-unit-y)): check-%: %
	$(call quiet-command,gtester $(GTESTER_OPTIONS) -m=$(SPEED) $*,"GTESTER $*")

# gtester tests with XML output

$(patsubst %, check-report-qtest-%.xml, $(QTEST_TARGETS)): check-report-qtest-%.xml: $(check-qtest-y)
	$(call quiet-command,QTEST_QEMU_BINARY=$*-softmmu/qemu-system-$* \
	  gtester -q $(GTESTER_OPTIONS) -o $@ -m=$(SPEED) $(check-qtest-$*-y),"GTESTER $@")

check-report-unit.xml: $(check-unit-y)
	$(call quiet-command,gtester -q $(GTESTER_OPTIONS) -o $@ -m=$(SPEED) $^, "GTESTER $@")

# Reports and overall runs

check-report.xml: $(patsubst %,check-report-qtest-%.xml, $(QTEST_TARGETS)) check-report-unit.xml
	$(call quiet-command,$(SRC_PATH)/scripts/gtester-cat $^ > $@, "  GEN    $@")

check-report.html: check-report.xml
	$(call quiet-command,gtester-report $< > $@, "  GEN    $@")


# Other tests

.PHONY: check-tests/qemu-iotests-quick.sh
check-tests/qemu-iotests-quick.sh: tests/qemu-iotests-quick.sh qemu-img$(EXESUF) qemu-io$(EXESUF)
	$<

# Consolidated targets

.PHONY: check-qtest check-unit check
check-qtest: $(patsubst %,check-qtest-%, $(QTEST_TARGETS))
check-unit: $(patsubst %,check-%, $(check-unit-y))
check-block: $(patsubst %,check-%, $(check-block-y))
check: check-unit check-qtest

-include $(wildcard tests/*.d)

=== debian/changelog ===
qemu (1.3.0+dfsg-5expubuntu4) raring; urgency=low

  * Update workarounds for udev/inotify:  (LP: #1092715)
    - qemu-system-common.udev: go back to original, simple rule
    - qemu-system-common.postinst: manually run setfacl
    - (keep Depends: on acl as well)
    - this can be removed once bug 1092715 is fixed.

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Tue, 19 Feb 2013 12:41:22 -0600

qemu (1.3.0+dfsg-5expubuntu3) raring; urgency=low

  * Now that qemu provides spice support, and qemu-kvm-spice is removed from
    the archive, have qemu-kvm (which qemu-kvm-spice always depended on)
    P/C/R qemu-kvm-spice.

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Thu, 14 Feb 2013 13:43:27 -0600

qemu (1.3.0+dfsg-5expubuntu2) raring; urgency=low

  * Enable spice.
  * Address lintian warning by adding ${misc:Depends} to qemu-common and
    qemu-kvm.

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Tue, 12 Feb 2013 16:07:04 -0600

qemu (1.3.0+dfsg-5expubuntu1) raring; urgency=low

  [ Serge Hallyn ]
  * Merge 1.3.0+dfsg-5exp from Debian.
  * remaining changes from 1.3.0+dfsg-1~exp3ubuntu1:
    - debian/control:
      * update maintainer
      * remove vde2 recommends
      * build-deps: remove libusbredir, libvdeplug2-dev,
        libspice-server-dev, libspice-protocol-dev, libiscsi-dev
      * qemu-system:
        - break/replace qemu-common
        - depend on udev
        - remove openbios-ppc, openbios-sparc, and openhackware from
          Depends.  (Intend to add them back once we can build them.)
      * qemu-utils: break/replace qemu-kvm
    - qemu-kvm.upstart:
      - add qemu-system.qemu-kvm.upstart
      - debian/rules: add dh_installinit to get qemu-system.upstart installed.
      - take the defaults from the old qemu-kvm.defaults, and move them into
        the upstart job
    - debian/patches:
      - apply gridcentric patches from lp:~amscanne/+junk/gridcentric-qemu-patches
      - apply arm patches from git://git.linaro.org/qemu/qemu-linaro.git
    - add links for qemu-ifup/down in qemu-system-common.links
    - debian/qemu-system-common.postinst
      - udevadm trigger to fix up /dev/kvm perms
    - debian/qemu-system.links:
      - remove pxe-virtio, pxe-e1000 and pxe-rtl8139 links (which conflict
        with ones from kvm-ipxe).  We may want to move the links from kvm-ipxe
        back to qemu-system at some point.
  * remaining changes from after 1.3.0+dfsg-1~exp3ubuntu1:
    - qemu-system-common.links: add link for OVMF
    - Add qemu-utils.links for kvm-img and kvm-nbd utils and manpages.
    - qemu-system.links:
      * Add link to usr/share/ovmf/OVMF.fd
      * Fix target of /etc/kvm/kvm-if{up,down} links
    - debian/control: qemu-system should Recommend cpu-checker
    - Add qemu-kvm breaks/replaces to qemu-user, to handle conflict over
      (i.e.) qemu-x86_64.
    - add qemu-kvm, and qemu-common transitional packages.
    - Add breaks/replaces to qemu-keymaps for qemu-system.
    - Add provides: qemu-kvm and kvm to qemu-system-ppc.
    - Add breaks/replaces to qemu-system-ppc for qemu-kvm and qemu-common.
    - Add breaks/replaces to qemu-kvm for qemu-common.
    - Add breaks/replaces to qemu-utils for qemu-user and qemu-kvm.
    - Add armhf, armel, powerpc and sparc arches to qemu-kvm transitional
      package.
    - Add qemu-common package.
    - Make sure /dev/kvm gets its acls cleared:
      * Add acl to qemu-system.depends
      * update qemu-system.udev to run setfacl to set g::rw acl
    - Remove vnc-jpeg, libiscsi-dev, and vde from debian/configure-opts
  * dropped debian/patches/CVE-2012-6075.patch (duplicate of
    e1000-discard-oversize-packets-based-on-SBP_LPE.patch)
  * debian/{control,configure-opts}: enable rbd (LP: #1118406)
  * add symlink for kvm.1 -> qemu.1 manpage (LP: #1117636)
  * add replaces to qemu-system-common for qemu - we briefly moved conflicting
    docs to qemu, which debian moved to qemu-system-common.  This can be
    dropped after raring.
  * move qemu-kvm.upstart from qemu-system to qemu-system-x86.
  * Support upgrade from qemu-kvm on non-x86 arches:
    - Add Provides: qemu-kvm, kvm to qemu-system-{arm,ppc,sparc,x86}
    - Add Breaks/Replaces for qemu-{common,system,kvm} and kvm.
  * Re-add expose_vms_qemu64cpu.patch (from Daviey) from quantal.
  
  [ Steve Langasek ]
  * Pass --enable-uname-release=2.6.32 for the user emulation builds, so that
    we have a sensible baseline kernel value regardless of what the
    underlying host kernel is.  This makes eglibc happier when running under
    emulation on a very old kernel for instance (whose host syscall ABI has
    nothing to do with what emulated syscalls are supported), and probably
    also lets us steer clear for the moment of code that has problem with
    the new kernel upstream versioning convention.  LP: #921078.

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Thu, 07 Feb 2013 14:15:26 -0600

qemu (1.3.0+dfsg-5exp) experimental; urgency=low

  * qemu-system-split: split qemu-system into several target-specific packages:
    qemu-system-arm, qemu-system-mips, qemu-system-ppc, qemu-system-sparc,
    qemu-system-x86, and qemu-system-misc, plus qemu-system-common.
    (Closes: #636000)
  * add initial qemu-guest-agent package (just the binary for now,
    no startup script) (Closes: #676959)
  * do not try to install (linux-specific) virtfs-proxy-helper on kfreebsd
  * change order of audio drivers, in particular put pulseaudio (pa) first
  * ship OS-specific qemu-ifup (use trivial ifconfig invocation on kfreebsd)
  * qemu-system replaces qemu-utils due to virtfs-proxy-helper binary
  * chmod +x qemu-ifdown

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 28 Jan 2013 15:05:57 +0400

qemu (1.3.0+dfsg-4exp) experimental; urgency=low

  * install forgotten /etc/qemu-ifdown (dummy, but qemu complains without it)
  * install virtfs-proxy-helper in qemu-system not qemu-utils
  * add qemu-kvm.NEWS mentioning transition from qemu-kvm to qemu-system-x86_64.


=== debian/rules ===
#!/usr/bin/make -f
#
# $Id: rules 391 2009-03-07 05:21:19Z aurel32 $
#

# support parallel build using DEB_BUILD_OPTIONS=parallel=N
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEFLAGS += -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# Packaging version
DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')

# Compiler flags
CFLAGS = $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

# Architecture/system specific configuration
DEB_HOST_ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS = $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

common_configure_opts = \
	--with-pkgversion="Debian $(DEB_VERSION)" \
	--extra-cflags="$(CFLAGS)" \
	--extra-ldflags="$(LDFLAGS)" \
	--prefix=/usr \
	--sysconfdir=/etc \
	--libexecdir=/usr/lib \
	--disable-blobs \
	--disable-strip \
	--with-system-pixman \
	--interp-prefix=/etc/qemu-binfmt/%M \
	--localstatedir=/var \
	--enable-uname-release=2.6.32 \

# list of system (softmmu) targets, from ./configure
system_targets = \
 i386 x86_64 alpha arm cris lm32 m68k microblaze microblazeel \
 mips mipsel mips64 mips64el or32 ppc ppcemb ppc64 sh4 sh4eb \
 sparc sparc64 s390x xtensa xtensaeb unicore32

# qemu-system subpackages
sys_systems = arm mips ppc sparc x86
systems = ${sys_systems} misc
sysarch_arm   = $(filter arm,${system_targets})
sysarch_mips  = $(filter mips mipsel mips64 mips64el,${system_targets})
sysarch_ppc   = $(filter ppc ppc64 ppcemb,${system_targets})
sysarch_sparc = $(filter sparc sparc64,${system_targets})
sysarch_x86   = $(filter i386 x86_64,${system_targets})
sysarch_misc  = $(filter-out $(foreach s,${sys_systems},${sysarch_$s}),${system_targets})

ifeq ($(DEB_HOST_ARCH_OS),linux)

# list of linux-user targets, from ./configure
user_targets = \
 i386 x86_64 alpha arm armeb cris m68k microblaze microblazeel \
 mips mipsel or32 ppc ppc64 ppc64abi32 sh4 sh4eb sparc sparc64 sparc32plus \
 unicore32 s390x

# binfmt linux-user support

all_binfmt_targets = \
 $(patsubst debian/binfmts/qemu-%,%,$(wildcard debian/binfmts/qemu-*))

# find which targets needs to be filtered out, which is arch-dependent.
# Drop support for emulating amd64 on i386, http://bugs.debian.org/604712
filter_binfmts = $(shell \
 case $(DEB_HOST_ARCH) in \
   (amd64 | i386) echo i386 x86_64 ;;\
   (arm | armel | armhf) echo arm ;;\
   (mips | mipsel) echo $(DEB_HOST_ARCH) ;;\
   (powerpc) echo ppc ;;\
   (ppc64) echo ppc ppc64 ppc64abi32 ;;\
   (s390x) echo s390x ;;\
   (sparc | sparc64) echo sparc sparc32plus sparc64 ;;\
 esac)

binfmt_targets = $(filter-out $(filter_binfmts), $(all_binfmt_targets))

enable_linux_user = --enable-linux-user

else

enable_linux_user =

endif	# linux

configure-stamp: configure
	dh_testdir

	# system build
	mkdir -p qemu-build && cd qemu-build && \
		../configure ${common_configure_opts} \
			--enable-system --disable-user ${enable_linux_user} \
			$(shell sh debian/configure-opts $(DEB_HOST_ARCH) $(DEB_HOST_ARCH_OS)) \
			$(QEMU_CONFIGURE_OPTIONS)

ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
# Hack alert.  qemu-1.3 still needs this.
# On recent kFreebsd, old USB host API has been removed,
# but qemu did not learn to use new USB API.
# Just do not build USB host support.
	sed -i 's/^HOST_USB=bsd/HOST_USB=stub/' \
		$(CURDIR)/qemu-build/config-host.mak
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
# do not use debian/configure-opts here, all optional stuff will be enabled
# automatically, dependencies are already verified in the main build
	mkdir -p user-static-build && cd user-static-build && \
		../configure ${common_configure_opts} \
			--static --disable-system \
			--target-list="$(addsuffix -linux-user,${user_targets})"
endif
	touch $@

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: configure-stamp
	dh_testdir

	# system build
	$(MAKE) -C $(CURDIR)/qemu-build
	dtc -o qemu-build/pc-bios/bamboo.dtb pc-bios/bamboo.dts

# special case for spapr-rtas.bin file.
# this is an entry point for PPC architecture, which consists of just 5
# processor instructions.  We use a pre-compiled pseudo-assembler version
# in debian/spapr-rtas.hex which can be "compiled" using sed magic.
# After "compiling" it this way, we compare with the upstream version,
# it should be the same.
# Use /usr/bin/printf since dash's printf does not understand \xNN.
	/usr/bin/printf "$$(sed -n 's|^ .*:	\(.*\)	.*|\1|p' debian/spapr-rtas.hex | \
		tr -d ' \n' | sed 's|\([0-9a-f]\{2\}\)|\\x\1|g')" > \
		qemu-build/pc-bios/spapr-rtas.bin
ifeq ($(DEB_HOST_ARCH),powerpc)
	$(MAKE) -C qemu-build/pc-bios/spapr-rtas spapr-rtas.bin
	cmp qemu-build/pc-bios/spapr-rtas.bin \
	    qemu-build/pc-bios/spapr-rtas/spapr-rtas.bin
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
	# user-static build
	# we use this invocation to build just the binaries
	$(MAKE) -C $(CURDIR)/user-static-build $(foreach t,${user_targets},subdir-${t}-linux-user)
endif
	touch $@

clean:
	dh_testdir
	rm -rf $(CURDIR)/*-build/
	rm -f $(CURDIR)/*-stamp
	find $(CURDIR)/scripts/ -name '*.pyc' -delete || :
	dh_clean

define inst-system
	for x in postinst prerm; do \
	  sed 's/@ARCH@/${sysarch_$1}/' debian/qemu-system.$$x-in > debian/qemu-system-$1.$$x.debhelper; \
	done
	mkdir -p debian/qemu-system-$1/usr/share/man/man1 debian/qemu-system-$1/usr/bin
	for t in ${sysarch_$1}; do \
	    mv debian/tmp/usr/bin/qemu-system-$$t debian/qemu-system-$1/usr/bin/; \
	    echo ".so qemu.1" > debian/qemu-system-$1/usr/share/man/man1/qemu-system-$$t.1; \
	done
	echo sysarch:$1=${sysarch_$1} > debian/qemu-system-$1.substvars
	echo sysprovides:$1=${addprefix qemu-system-,${filter-out $1,${sysarch_$1}}} | \
	  sed -e 's/ /, /g' -e 'y/_/-/' >> debian/qemu-system-$1.substvars

endef

install: build-stamp
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs -a

	# system build
	$(MAKE) -C $(CURDIR)/qemu-build DESTDIR=$(CURDIR)/debian/tmp install

	# qemu-system subpackages
	$(foreach s,${systems},$(call inst-system,$s))

ifeq ($(DEB_HOST_ARCH_OS),linux)

# /usr/bin/kvm compat script.  This needs some more work for other arches
# How about a manpage for it?
ifneq ($(filter $(DEB_HOST_ARCH),amd64 i386),)
	dh_install -pqemu-system-x86 debian/kvm /usr/bin/
endif

# virtfs-proxy-helper is linux-specific
	for f in usr/bin/virtfs-proxy-helper \
	         usr/share/man/man1/virtfs-proxy-helper.1 ; do \
	  mkdir -p debian/qemu-system-common/$${f%/*} ; \
	  mv debian/tmp/$$f debian/qemu-system-common/$$f ; \
	done

	# qemu-user
	mkdir -p debian/qemu-user/usr/bin debian/qemu-user/usr/share/man/man1
	for t in ${user_targets}; do \
	    mv debian/tmp/usr/bin/qemu-$$t \
		debian/qemu-user/usr/bin ; \
	    ln -s qemu-user.1 \
		debian/qemu-user/usr/share/man/man1/qemu-$$t.1 ; \
	done

	# qemu-user-static
	mkdir -p debian/qemu-user-static/usr/bin debian/qemu-user-static/usr/share/man/man1
	for t in ${user_targets}; do \
	    cp -p user-static-build/$$t-linux-user/qemu-$$t \
		debian/qemu-user-static/usr/bin/qemu-$$t-static ; \
	    ln -s qemu-user-static.1 \
		    debian/qemu-user-static/usr/share/man/man1/qemu-$$t-static.1 ; \
	done

	# binfmt support
	for x in postinst prerm; do \
	    sed 's/@BINFMT_TARGETS@/${all_binfmt_targets}/' \
		debian/qemu-user-static.$$x-in > debian/qemu-user-static.$$x.debhelper ; \
	done

	mkdir -p debian/qemu-user-static/usr/share/binfmts
	install -m 644 -t debian/qemu-user-static/usr/share/binfmts/ \
		$(addprefix debian/binfmts/qemu-,${binfmt_targets})
endif

# qemu-ifup is arch-specific
	install -D debian/qemu-ifup.$(DEB_HOST_ARCH_OS) \
		debian/qemu-system-common/etc/qemu-ifup

	dh_install --list-missing
	dh_installdocs
	dh_installinit -pqemu-system-x86 --no-restart-on-upgrade --error-handler=true --name=qemu-kvm
	dh_installchangelogs Changelog
	dh_installudev
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary-indep: install

## qemu 1.4.0+dfsg

=== debian/changelog ===
qemu (1.4.0+dfsg-1expubuntu4) raring; urgency=low

  * re-add qemu-system-x86.modprobe to set nesting=1 (LP: #1155177)
  * qemu-system-x86.qemu-kvm.upstart:
    - remove NESTED workarounds from upstart file.
    - remove loading of modules which is now always done
    - remove TAPR define which is no longer used
  * move customizable defines back to qemu-kvm.default
  * copy creation of group kvm to preinst - the group must exist when the
    kvm udev rule is installed (LP: #1103022) (LP: #1092715)
  * add adduser to qemu-system-common Pre-Depends for use by preinst.

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Thu, 14 Mar 2013 14:21:53 -0500

qemu (1.4.0+dfsg-1expubuntu3) raring; urgency=low

  * debian/rules: add a symlink from kvm-spice to kvm in qemu-kvm, on
    i386/amd64 targets.  (LP: #1126258)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Thu, 28 Feb 2013 15:17:16 -0600

qemu (1.4.0+dfsg-1expubuntu2) raring; urgency=low

  * substitute (apparently identical) patches from 1.4.0 qemu-linaro rebasing
    tree.
  * add qemu-common to qemu-system-common B/R (was accidentally dropped from
    1.3.0 in 1.4.0 merge).
  * debian/control: fix kvm P/C/B/R:
    - make all C/B/R against kvm versioned
    - don't have any qemu-system-* other than x86 Provides: kvm

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Fri, 22 Feb 2013 13:34:07 -0600

qemu (1.4.0+dfsg-1expubuntu1) raring; urgency=low

  * Merge 1.4.0+dfsg-1exp from debian.  Remaining changes:
    - debian/control:
      * update maintainer
      * remove libiscsi, usb-redir, vde, and vnc-jpeg from build-deps
      * enable rbd
      * add qemu-system and qemu-common B/R to qemu-keymaps
      * add D:udev and R:qemu to qemu-system-common
      * qemu-system-arm, qemu-system-ppc, qemu-system-sparc:
        - add qemu-kvm and kvm to Provides
        - add qemu-common and qemu-kvm to Breaks/Replaces qemu-system-ppc,
          qemu-system-sparc:
        - remove openbios-$arch from Depends
      * qemu-system-x86:
        - add qemu-common to Breaks/Replaces.
        - add cpu-checker to Recommends.
      * qemu-user:
        - add B/R qemu-kvm
      * qemu-utils:
        - add B/R qemu-user and qemu-kvm
      * qemu-kvm: add armhf armel powerpc sparc to Architecture
      * add qemu-common package
    - add qemu-system-common.links for tap ifup/down scripts and OVMF link.
    - qemu-system-x86.links:
      * remove pxe rom links which are in kvm-ipxe
      * add symlink for kvm.1 manpage
    - Add qemu-utils.links for kvm-* symlinks.
    - Add qemu-kvm.conf upstart job to qemu-system
    - Clear /dev/kvm acls on install
    - Add linaro arm patches.
    - Add gridcentric patches.
    - Re-add expose_vms_qemu64cpu.patch (from Daviey)
  * Add 0001-fix-wrong-output-with-info-chardev-for-tcp-socket.patch

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Wed, 20 Feb 2013 11:58:27 -0600

qemu (1.4.0+dfsg-1exp) experimental; urgency=low

  [ Michael Tokarev ]
  * 1.4.0 final release
  * remove fix-virtio-net-for-win-guests.patch (upstream now has better fix)
  * fix debian/control arch fields. Build-Depends: foo [bar]
    means foo will be selected for build on LINUX-bar, not any-bar.
    So stop using [bar], always use [linux-bar] or [any-bar],
    as appropriate.  This fix spice and xen (non)selection on
    kfreebsd-{i386,amd64}.
  * fix manpage "links" generation (man qemu-system-* was broken)
  * change Vcs fields to point to anonscm.debian.org (lintian)
  * add a check for (lxc) container to qemu-system-x86 initscript

  [ Michael Tokarev - committed after 1.4.0+dfsg-1exp]
  * fix distribution field in last qemu-system.NEWS entry
  * bump Standards-Version to 3.9.4 (no changes needed)
  * pre-Depend on adduser for qemu-system-common (Closes: #700840)

  [ Steve Langasek ]
  * Pass --enable-uname-release=2.6.32 for the user emulation builds, so that
    we have a sensible baseline kernel value regardless of what the
    underlying host kernel is.  This makes eglibc happier when running under
    emulation on a very old kernel for instance (whose host syscall ABI has
    nothing to do with what emulated syscalls are supported), and probably
    also lets us steer clear for the moment of code that has problem with
    the new kernel upstream versioning convention.  LP: #921078.

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 16 Feb 2013 12:34:54 +0400

qemu (1.4.0~rc0+dfsg-1exp) experimental; urgency=low

  * new upstream 1.4.0-rc0 (first release candidate).
    (Closes: #549195)
  * remove patches included upstream:
    e1000-discard-oversized-packets-based-on-SBP_LPE.patch
    link-seccomp-only-with-softmmu-targets.patch
    revert-serial-fix-retry-logic.patch
    savevm.c-cleanup-system-includes.patch
  * refresh qemu-ifunc-sparc.patch
  * add fix-virtio-net-for-win-guests.patch bandaid to make virtio-net
    in windows guest to work again
  * don't install virtfs-proxy-helper in its own subdir in /usr/bin
  * add qemu-io manpage.  Thank you Asias He for the work!
    (Closes: #652518)
  * move config options from debian/configure-opts into debian/control,
    to keep list of build-deps & corresponding config flags in one place
  * use initscript from old qemu-kvm package to load kvm modules for
    qemu-system-x86, and clean it up (Closes: #699404)
  * load vhost_net module in the initscript too
  * mention default NIC change in qemu-kvm.NEWS and old conffiles
  * remove mentions of (ubuntu-specific) qemu-common from debian/control
    for now, as it does not help anyway (other changes are needed anyway
    and it is better to keep them in one place)
  * add a (preliminary) qemu-guest-agent startup script
  * qemu-system-x86 break libvirt0 << 1.0, because older versions
    didn't work with qemu 1.3+ correctly

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 02 Feb 2013 21:05:28 +0400

qemu (1.3.0+dfsg-5expubuntu5) raring; urgency=low

  * qemu-system-common.postinst: only run setfacl when /dev/kvm exists.
    (LP: #1130591)



=== debian/control ===
Source: qemu
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
Uploaders: Aurelien Jarno <aurel32@debian.org>,
	Riku Voipio <riku.voipio@iki.fi>,
	Vagrant Cascadian <vagrant@debian.org>,
	Michael Tokarev <mjt@tls.msk.ru>
Build-Depends: debhelper (>= 9),
# In comments below we also specify (system-specific) arguments
# to qemu's configure script, -- optional features which depend
# on build-dependencies.
# pc-bios/*.dts => *.dtb (PPC firmware)
 device-tree-compiler,
 texi2html,
 texinfo,
 python,
# --enable-linux-aio	linux-*
 libaio-dev [linux-any],
# --audio-drv-list=pa,alsa,sdl,oss	linux-*
# --audio-drv-list=pa,oss,sdl		kfreebsd-*
 libasound2-dev [linux-any],
# for virtfs
# --enable-attr
 libattr1-dev,
# --enable-bluez	linux-*
 libbluetooth-dev [linux-any],
# --enable-brlapi
 libbrlapi-dev,
# --enable-virtfs	linux-*
# needed for virtfs
 libcap-dev [linux-any],
# --enable-cap-ng	linux-*
 libcap-ng-dev [linux-any],
# --enable-curl
 libcurl4-gnutls-dev,
# --enable-fdt
 libfdt-dev,
# --enable-vnc-tls
# --enable-vnc-ws
 libgnutls-dev,
# --enable-curses
 libncurses5-dev,
# --with-system-pixman
 libpixman-1-dev,
# audio-drv-list += pa
 libpulse-dev,
# --enable-vnc-sasl
 libsasl2-dev,
# --enable-sdl
 libsdl1.2-dev (>> 1.2.1),
# --enable-seccomp	linux-amd64|linux-i386
 libseccomp-dev (>> 1.0.0) [linux-amd64 linux-i386],
# --enable-spice	linux-amd64|linux-i386
 libspice-server-dev (>= 0.12.2~) [linux-amd64 linux-i386],
# needed for sdl
 libx11-dev,
# --enable-xen	linux-amd64|linux-i386
 libxen-dev [linux-amd64 linux-i386],
# XXX need to check minimum linux-headers requiriment
 linux-libc-dev (>= 2.6.34) [linux-any],
# --enable-uuid
 uuid-dev,
# --enable-xfsctl	linux-*
 xfslibs-dev [linux-any],
# always needed
 zlib1g-dev,
# other optional features we enable
# --enable-vnc
# --enable-vnc-png
# --enable-kvm		linux-*
# --enable-vhost-net	linux-*	# is it really linux-specific?
##--enable-glusterfs todo
# --enable-rbd
 librados-dev, librbd-dev,
Build-Conflicts: oss4-dev
Standards-Version: 3.9.4
Homepage: http://www.qemu.org/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-qemu/qemu.git
Vcs-Git: git://anonscm.debian.org/pkg-qemu/qemu.git

Package: qemu
Architecture: amd64 arm armel armhf hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel powerpc ppc64 s390x sparc sparc64
Multi-Arch: foreign
Depends: ${misc:Depends}, qemu-system (>= ${source:Version}), qemu-user (>= ${source:Version}) [linux-any], qemu-utils (>= ${source:Version})
Suggests: qemu-user-static [linux-any]
Description: fast processor emulator
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs. QEMU has
 two operating modes:
 .
  * User mode emulation: QEMU can launch Linux processes compiled for
    one CPU on another CPU.
  * Full system emulation: QEMU emulates a full system, including a
    processor and various peripherals. It enables easier testing and
    debugging of system code. It can also be used to provide virtual
    hosting of several virtual machines on a single server.
 .
 As QEMU requires no host kernel patches to run, it is very safe and
 easy to use.
 .
 This package is a metapackage depending on all qemu-related packages.

Package: qemu-keymaps
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: qemu-system (<< 0.12.4+dfsg-4), qemu-common (<< 1.2.0.dfsg-1)
Replaces: qemu-system (<< 0.12.4+dfsg-4), qemu-common (<< 1.2.0.dfsg-1)
Description: QEMU keyboard maps
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides keyboard maps to be used by the qemu-system
 package or QEMU derivatives.

Package: qemu-system
Architecture: amd64 arm armel armhf hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel powerpc ppc64 s390x sparc sparc64
Multi-Arch: foreign
Depends: ${misc:Depends},
 qemu-system-arm,
 qemu-system-mips,
 qemu-system-ppc, 
 qemu-system-sparc, 
 qemu-system-x86,
 qemu-system-misc 
Description: QEMU full system emulation binaries
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides the full system emulation binaries. In this mode
 QEMU emulates a full system, including a processor and various
 peripherals. It enables easier testing and debugging of system code.
 It can also be used to provide virtual hosting of several virtual
 machines on a single server.

Package: qemu-system-common
Architecture: amd64 arm armel armhf hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel powerpc ppc64 s390x sparc sparc64
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}, udev, acl
Pre-Depends: adduser
Breaks:
# qemu-common is ubuntu package
  qemu-common (<< 1.2.0.dfsg-1),
# qemu-system before qemu-system-split
  qemu-system (<< 1.3.0+dfsg-5),
# qemu-utils had virtfs-proxy-helper
  qemu-utils (<< 1.3.0+dfsg-4),
# iproute before 20110315 were unable to deal with bridge (set master device)
  iproute (<< 20110315-1)
Replaces:
  qemu (<< 1.3.0+dfsg-5),
  qemu-common (<< 1.2.0.dfsg-1),
  qemu-system (<< 1.3.0+dfsg-5),
  qemu-utils (<< 1.3.0+dfsg-4),
Description: QEMU full system emulation binaries (common files)
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, i386, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, SH4,
 SPARC and x86-64 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides the full system emulation binaries. In this mode
 QEMU emulates a full system, including a processor and various
 peripherals. It enables easier testing and debugging of system code.
 It can also be used to provide virtual hosting of several virtual
 machines on a single server.

Package: qemu-system-misc
Architecture: amd64 arm armel armhf hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel powerpc ppc64 s390x sparc sparc64
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends},
 qemu-system-common (>= ${source:Version}), qemu-keymaps (>= ${source:Version}),
Provides: ${sysprovides:misc}
Breaks: qemu-system (<< 1.3.0+dfsg-5)
Replaces: qemu-system (<< 1.3.0+dfsg-5)
Recommends: qemu-utils
Suggests: samba, vde2
Description: QEMU full system emulation binaries (miscelaneous)
 QEMU is a fast processor emulator: currently the package supports
 ARM, CRIS, M68k (ColdFire), MicroBlaze, and SH4
 emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides the full system emulation binaries to emulate
 various other hardware which did not made into separate packages.
 Emulators for the following architectures are provided:
  ${sysarch:misc}.
 .
 In system emulation mode QEMU emulates a full system, including a processor
 and various peripherals.  It enables easier testing and debugging of system
 code.  It can also be used to provide virtual hosting of several virtual
 machines on a single server.

Package: qemu-system-arm
Architecture: amd64 arm armel armhf hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel powerpc ppc64 s390x sparc sparc64
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends},
 qemu-system-common (>= ${source:Version}), qemu-keymaps (>= ${source:Version}),
Provides: ${sysprovides:arm}, qemu-kvm
Breaks:
  qemu-common (<< 1.3.0+dfsg-5),
  qemu-system (<< 1.3.0+dfsg-5),
  qemu-kvm (<< 1.2.0.dfsg-1),
  kvm (<< 1.3.0+dfsg-5)
Replaces:
  qemu-common (<< 1.3.0+dfsg-5),
  qemu-system (<< 1.3.0+dfsg-5),
  qemu-kvm (<< 1.2.0.dfsg-1),
  kvm (<< 1.3.0+dfsg-5)
Recommends: qemu-utils
Suggests: samba, vde2
Description: QEMU full system emulation binaries (arm)
 QEMU is a fast processor emulator: currently the package supports
 ARM emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides the full system emulation binaries to emulate
 the following arm hardware: ${sysarch:arm}.
 .
 In system emulation mode QEMU emulates a full system, including a processor
 and various peripherals.  It enables easier testing and debugging of system
 code.  It can also be used to provide virtual hosting of several virtual
 machines on a single server.

Package: qemu-system-mips
Architecture: amd64 arm armel armhf hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel powerpc ppc64 s390x sparc sparc64
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends},
 qemu-system-common (>= ${source:Version}), qemu-keymaps (>= ${source:Version}),
Provides: ${sysprovides:mips}
Breaks: qemu-system (<< 1.3.0+dfsg-5)
Replaces: qemu-system (<< 1.3.0+dfsg-5)
Recommends: qemu-utils
Suggests: samba, vde2
Description: QEMU full system emulation binaries (mips)
 QEMU is a fast processor emulator: currently the package supports
 MIPS emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides the full system emulation binaries to emulate
 the following mips hardware: ${sysarch:mips}.
 .
 In system emulation mode QEMU emulates a full system, including a processor
 and various peripherals.  It enables easier testing and debugging of system
 code.  It can also be used to provide virtual hosting of several virtual
 machines on a single server.

Package: qemu-system-ppc
Architecture: amd64 arm armel armhf hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel powerpc ppc64 s390x sparc sparc64
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends},
 qemu-system-common (>= ${source:Version}), qemu-keymaps (>= ${source:Version}),
Provides: ${sysprovides:ppc}, qemu-kvm
Breaks: qemu-system (<< 1.3.0+dfsg-5), qemu-kvm (<< 1.2.0.dfsg-1), qemu-common (<< 1.2.0.dfsg-1), kvm (<< 1.3.0+dfsg-5)
Replaces: qemu-system (<< 1.3.0+dfsg-5), qemu-kvm (<< 1.2.0.dfsg-1), qemu-common (<< 1.2.0.dfsg-1), kvm (<< 1.3.0+dfsg-5)
Recommends: qemu-utils
Suggests: samba, vde2
Description: QEMU full system emulation binaries (ppc)
 QEMU is a fast processor emulator: currently the package supports
 PowerPC emulation. By using dynamic translation it achieves
 reasonable speed while being easy to port on new host CPUs.
 .
 This package provides the full system emulation binaries to emulate
 the following PowerPC hardware: ${sysarch:ppc}.
 .
 In system emulation mode QEMU emulates a full system, including a processor
 and various peripherals.  It enables easier testing and debugging of system
 code.  It can also be used to provide virtual hosting of several virtual
 machines on a single server.

Package: qemu-system-sparc
Architecture: amd64 arm armel armhf hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips mipsel powerpc ppc64 s390x sparc sparc64
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends},
 qemu-system-common (>= ${source:Version}), qemu-keymaps (>= ${source:Version}),
Provides: ${sysprovides:sparc}, qemu-kvm
Breaks:
  qemu-common (<< 1.3.0+dfsg-5),
  qemu-system (<< 1.3.0+dfsg-5),
  qemu-kvm (<< 1.2.0.dfsg-1),
  kvm (<< 1.3.0+dfsg-5)
Replaces:
  qemu-common (<< 1.3.0+dfsg-5),
  qemu-system (<< 1.3.0+dfsg-5),
  qemu-kvm (<< 1.2.0.dfsg-1),
  kvm (<< 1.3.0+dfsg-5)
Recommends: qemu-utils
Suggests: samba, vde2
Description: QEMU full system emulation binaries (sparc)
 QEMU is a fast processor emulator: currently the package supports

=== debian/rules ===
--- 
+++ 
@@ -19,6 +19,7 @@
 DEB_HOST_ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH)
 DEB_HOST_ARCH_OS = $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
 
+# we add another set of configure options from debian/control
 common_configure_opts = \
 	--with-pkgversion="Debian $(DEB_VERSION)" \
 	--extra-cflags="$(CFLAGS)" \
@@ -31,6 +32,7 @@
 	--with-system-pixman \
 	--interp-prefix=/etc/qemu-binfmt/%M \
 	--localstatedir=/var \
+	--audio-card-list=ac97,es1370,sb16,cs4231a,adlib,gus,hda \
 	--enable-uname-release=2.6.32 \
 
 # list of system (softmmu) targets, from ./configure
@@ -90,10 +92,11 @@
 
 	# system build
 	mkdir -p qemu-build && cd qemu-build && \
-		../configure ${common_configure_opts} \
-			--enable-system --disable-user ${enable_linux_user} \
-			$(shell sh debian/configure-opts $(DEB_HOST_ARCH) $(DEB_HOST_ARCH_OS)) \
-			$(QEMU_CONFIGURE_OPTIONS)
+	   ../configure ${common_configure_opts} \
+		--enable-system --disable-user ${enable_linux_user} \
+		$(shell sh debian/extract-config-opts \
+		    $(DEB_HOST_ARCH_OS)-$(DEB_HOST_ARCH) debian/control) \
+		$(QEMU_CONFIGURE_OPTIONS)
 
 ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
 # Hack alert.  qemu-1.3 still needs this.
@@ -161,7 +164,7 @@
 	mkdir -p debian/qemu-system-$1/usr/share/man/man1 debian/qemu-system-$1/usr/bin
 	for t in ${sysarch_$1}; do \
 	    mv debian/tmp/usr/bin/qemu-system-$$t debian/qemu-system-$1/usr/bin/; \
-	    echo ".so qemu.1" > debian/qemu-system-$1/usr/share/man/man1/qemu-system-$$t.1; \
+	    echo ".so man1/qemu.1" > debian/qemu-system-$1/usr/share/man/man1/qemu-system-$$t.1; \
 	done
 	echo sysarch:$1=${sysarch_$1} > debian/qemu-system-$1.substvars
 	echo sysprovides:$1=${addprefix qemu-system-,${filter-out $1,${sysarch_$1}}} | \
@@ -187,6 +190,10 @@
 # How about a manpage for it?
 ifneq ($(filter $(DEB_HOST_ARCH),amd64 i386),)
 	dh_install -pqemu-system-x86 debian/kvm /usr/bin/
+	mkdir -p debian/qemu-kvm/usr/bin
+	ln -s kvm debian/qemu-kvm/usr/bin/kvm-spice
+	ln -s qemu-system-x86_64 debian/qemu-kvm/usr/bin/qemu-system-x86_64-spice
+	dh_installmodules -pqemu-system-x86
 endif
 
 # virtfs-proxy-helper is linux-specific
@@ -227,21 +234,3 @@
 
 # qemu-ifup is arch-specific
 	install -D debian/qemu-ifup.$(DEB_HOST_ARCH_OS) \
-		debian/qemu-system-common/etc/qemu-ifup
-
-	dh_install --list-missing
-	dh_installdocs
-	dh_installinit -pqemu-system-x86 --no-restart-on-upgrade --error-handler=true --name=qemu-kvm
-	dh_installchangelogs Changelog
-	dh_installudev
-	dh_link
-	dh_strip
-	dh_compress
-	dh_fixperms
-	dh_installdeb
-	dh_shlibdeps
-	dh_gencontrol
-	dh_md5sums
-	dh_builddeb
-
-binary-indep: install
